// PulseGenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PulseGen.h"
#include "PulseGenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPulseGenDlg dialog

CPulseGenDlg::CPulseGenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPulseGenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPulseGenDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPulseGenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPulseGenDlg)
	DDX_Control(pDX, IDC_REARM, m_rearm);
	DDX_Control(pDX, IDC_START, m_start);
	DDX_Control(pDX, IDC_EXIT, m_exit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPulseGenDlg, CDialog)
	//{{AFX_MSG_MAP(CPulseGenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN_INIT, OnOpenInit)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_REARM, OnRearm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPulseGenDlg message handlers

BOOL CPulseGenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    // set out pointers equal to something
	m_pSR=NULL;
    m_driverInstance=NULL;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPulseGenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPulseGenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPulseGenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPulseGenDlg::OnOpenInit() 
{
	// pass in driver name to avoid the Open DriverLINX Dialog
m_driverInstance=OpenDriverLINX(m_hWnd,"kpci3140"); //Open DriverLINX driver, and bring up the dialog box to pick a driver
m_pSR=(DL_ServiceRequest*) new (DL_ServiceRequest); //get a pointer to the service request
memset(m_pSR,0,sizeof(DL_ServiceRequest)); //Initialize the members of the service request
DL_SetServiceRequestSize(*m_pSR); //Need to set the service request size member
m_pSR->device=0; //set the device number (DriverLINX Config Panel setting)
m_pSR->operation=INITIALIZE; //Need to initialize the device before we can use it
m_pSR->subsystem=DEVICE;  //the initialize function is part of the DEVICE subsystem
m_pSR->mode=OTHER;  //Initialize is not a polled, interrupt, or dma operation, so we use OTHER
m_pSR->hWnd=m_hWnd;  //Need to set the hWnd member to the window handle of the application
//Execute the initialize service
 //show any errors	

if (DriverLINX(m_pSR) == NoErr)
{
	// success
m_start.EnableWindow(TRUE);  // enable the buttons
m_rearm.EnableWindow(FALSE);
m_exit.EnableWindow(FALSE);  // disable exit button
UpdateData(FALSE);
}
else
{  // problem has occured
showMessage(m_pSR);  // display the error message box

}

// set focus back to our dialog
CWnd::SetActiveWindow();	
CWnd::CenterWindow();
	
}

void CPulseGenDlg::OnStart() 
{
/*
               onCount
 _____________         _____________         _____________
              |       |             |       |
		      |       |             |       | 
		       -------               --------

  OUTPUT from a C/T of KPCI-3140 will normally be logic 1, so if your
  application can be designed to use active lo pulses, every thing will be
  easier to implement.  Allow the output to be normally high and go low for the
  programmed amount of time (onCount).

  Alternately, you can generate active hi pulses, but the output will not go to
  the low state until the task is started.  As soon as task is stopped, the output
  will go back to it's default state of hi.  Best to add an inverter or other hardware
  solution if need the output to normally be low.

*/

// setup the DriverLINX task
m_pSR->operation=START;  // start operation
m_pSR->subsystem=CT;     // using CT subsystem
m_pSR->mode=POLLED;      // no timing info required.....POLLED mode
m_pSR->start.typeEvent=COMMAND;   // start when we call DriverLINX function
m_pSR->timing.typeEvent=RATEEVENT;  // speed of the task will be specified
m_pSR->stop.typeEvent=NULLEVENT;  // no stop type required
m_pSR->timing.u.rateEvent.channel=0;   // use channel 0 of CT subsystem
m_pSR->timing.u.rateEvent.mode=PULSEGEN;  // generate a Pulse
m_pSR->timing.u.rateEvent.pulses=1;  
m_pSR->timing.u.rateEvent.pulses |= OUTPUTLOTOGGLED;  // OUTPUTHITOGGLED for active hi pulse
m_pSR->timing.u.rateEvent.clock=INTERNAL1;  // the only internal timebase, 40MHz, for KPCI-3140
/*
 The internal timebase of 40MHz is quite fast : it tics every 25 nano seconds.

  The period member programs the delay (how many tics of the timebase).
  The onCount member programs the duration of the pulse (how many tics of the timebase).

  The sum of these two members can not exceed 65535 since we are dealing
  with 16bit counters to define the delay + pulse.

  Maximum pulse width is less than 1.6 msec (0.0016 seconds) using internal timebase:
  40M/65535 = 611 Hz  ----> 0.0016

  The Sec2Tics function can be used to convert time in seconds to 
  equivalent tics of the 40MHz timebase:
  Sec2Tics(logicalDevice Number,CT,INTERNAL1,time in seconds)

  NOTE:  for longer pulses than can be achieved with the internal timebase,
         use one channel to generate a slower freq square wave such as at 1KHz,etc.
*/

m_pSR->timing.u.rateEvent.period= 1; // the delay (must be at least one tic)
// the duration of the pulse is with the onCount member
m_pSR->timing.u.rateEvent.onCount= 65535 - (m_pSR->timing.u.rateEvent.period) ;

m_pSR->timing.u.rateEvent.gate=NOCONNECT;  // gating not used in this example
if (DriverLINX(m_pSR) == NoErr)  // start the task by calling DriverLINX function
{
	// success
m_exit.EnableWindow(TRUE);  // enable the exit button
m_rearm.EnableWindow(TRUE);
m_start.EnableWindow(FALSE);
}
else
{  // problem has occured
m_exit.EnableWindow(TRUE);  // enable the exit button
showMessage(m_pSR);  // display the error message box
}
}

void CPulseGenDlg::OnExit() 
{
// code to clean up after DriverLINX
if (m_driverInstance != NULL)
{
   CloseDriverLINX(m_driverInstance); //close the DriverLINX driver
   m_driverInstance=NULL; //make sure m_driverInstance isn't pointing to anything
}
if (m_pSR != NULL)
{
   delete(m_pSR); //de-allocate the memory used by the service request
   m_pSR=NULL;
}
	
     // close down our dialog
	CWnd::DestroyWindow();
}

void CPulseGenDlg::showMessage(DL_ServiceRequest *SR)
{
	SR->operation=MESSAGEBOX;
	DriverLINX(SR);
/*
// the code below could be used instead of the messagebox operation above

char errString[100];
DWORD size=50;
int errNumber;
errNumber = getErrCode(SR->result);
// errNumber corresponds to DriverLINX documentation
ReturnMessageString(SR->hWnd,SR->result,errString,size);
// errString corresponds to DriverLINX documentation
m_errMsg.Format("%s",errString);
UpdateData(FALSE);  // update the dialog
*/

	return;
}

void CPulseGenDlg::OnRearm() 
{
m_rearm.EnableWindow(FALSE);
m_start.EnableWindow(TRUE);

m_pSR->operation=STOP;
DriverLINX(m_pSR);

	
}
